#include <iostream>
#include <fstream>
#include <string>
using namespace std;

struct book{
string name;
string author;
string isbn="0";
int total_copy;
int left_copy;
int resrvd=0;
};

struct user{
int rollno=0;
string password;
string issued_book="0";
};

struct librarian{
int empno=0;
string pass;
};

void memberlogin(user a[],book lib[]);
void liblogin(librarian b[],book lib[]);
void registr(user a[]);
user memboptions(user a,book lib[]);
user booksearch(user a,book lib[]);
void reqbook();
void liboptions(librarian b,book lib[]);
void addbook(book lib[]);
void deletebook(book lib[]);
void viewreq(book lib[]);
int num(string x);

int main(){
int x,j=1;
user a[1000];
librarian b[10];
book lib[1000];

ifstream books("book.txt");
for (int m=0;;m++){
    string temp; int i=0,start=0;
    getline(books,temp);
    if (temp.substr(0,1)=="$") break;
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].name=temp.substr(start,i-start); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].author=temp.substr(start,i-start); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].isbn=temp.substr(start,i-start); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].total_copy=num(temp.substr(start,i-start)); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].left_copy=num(temp.substr(start,i-start)); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {lib[m].resrvd=num(temp.substr(start,i-start)); start=++i; break; }
    }
}
books.close();

ifstream users("user.txt");
for (int m=0;m<1000;m++){
    string temp; int i=0,start=0;
    getline(users,temp);
    if (temp.substr(0,1)=="$") break;
    for (;;i++){
        if (temp.substr(i,1)==",") {a[m].rollno=num(temp.substr(start,i-start)); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {a[m].password=temp.substr(start,i-start); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {a[m].issued_book=temp.substr(start,i-start); start=++i; break; }
    }
}
users.close();

ifstream libr("librarians.txt");
for (int m=0;m<10;m++){
    string temp; int i=0,start=0;
    getline(libr,temp);
    if (temp.substr(0,1)=="$") break;
    for (;;i++){
        if (temp.substr(i,1)==",") {b[m].empno=num(temp.substr(start,i-start)); start=++i; break; }
    }
    for (;;i++){
        if (temp.substr(i,1)==",") {b[m].pass=temp.substr(start,i-start); start=++i; break; }
    }
}
libr.close();

cout<<"    Welcome to Central Library \n \n";
do{
cout<<"Enter choice: \n\n    Member Login-            1 \n    Librarian Login-         2 \n    Registration-            3 \n    Exit-                    4 \n";
cin>>x;
switch (x){
    case 1: memberlogin(a,lib); break;
    case 2: liblogin(b,lib); break;
    case 3: registr(a); break;
    case 4: j=0; break;
    default: cout<<"Invalid input! \n";}
}while (j);
ofstream newbooks("book.txt", ios::ate);
for (int m=0;m<1000;m++){
    if (lib[m].isbn=="0") break;
    newbooks<<lib[m].name<<","<<lib[m].author<<","<<lib[m].isbn<<","<<lib[m].total_copy<<","<<lib[m].left_copy<<","<<lib[m].resrvd<<",\n";
}
newbooks<<"$";
newbooks.close();

ofstream newusers("user.txt", ios::ate);
for (int m=0;m<1000;m++){
    if (a[m].rollno==0) break;
    newusers<<a[m].rollno<<","<<a[m].password<<","<<a[m].issued_book<<",\n";
}
newusers<<"$";
newusers.close();
return 0;
}

void memberlogin(user a[],book lib[]){
user x; int i;
cout<<"\n Roll number: ";
cin>>x.rollno;
cout<<"\n Password: ";
cin>>x.password;
for (i=0;i<1000;i++){
    if (a[i].rollno==x.rollno && a[i].password==x.password)
    {a[i]=memboptions(a[i],lib); return;}
}
cout<<"\n  Invalid roll number or password. \n";
}

void liblogin(librarian b[],book lib[]){
int i;
librarian x;
cout<<"\n Employee number: ";
cin>>x.empno;
cout<<"\n Password: ";
cin>>x.pass;
for (i=0;i<1000;i++){
    if (b[i].empno==x.empno && b[i].pass==x.pass)
    {liboptions(b[i],lib); return;}
}
cout<<"\n  Invalid employee number or password. \n";
}

void registr(user a[]){
int i;
user x;
cout<<"\n Roll number: ";
cin>>x.rollno;
cout<<"\n Set password: ";
cin>>x.password;
for (i=0;i<1000,a[i].rollno!=-1;i++){
    if (a[i].rollno==x.rollno)
        {cout<<"\n  Roll number already exists. \n"; registr(a); i=1000; break;}
}
if (i!=1000){a[i].rollno=x.rollno; a[i].password=x.password;}
return;
}

user memboptions(user a,book lib[]){
int x;
int j=1,i;
do{
cout<<"Enter choice: \n\n    Search Book-             1 \n    Return Book-             2 \n    Request Book-            3 \n    Exit-                    4 \n";
cin>>x;
switch (x){
    case 1: a=booksearch(a,lib); break;
    case 2: for (i=0;;i++) {
                if (lib[i].isbn==a.issued_book) break;}
            cout<<"Return "<<lib[i].name<<" ? y/n ";
            char c;
            cin>>c;
            if (c=='y' || c=='Y') {
                    lib[i].left_copy++;
                    a.issued_book="0";
                    cout<<"      Book returned.\n";
                    break;
                    }
            else break;
    case 3: reqbook(); break;
    case 4: j=0; break;
    default: cout<<"      Invalid input! \n";}
}while (j);
return a;
}

user booksearch(user a,book lib[]){
int x;
string query;
cout<<"   Search using: \n      Name-          1 \n      Author-        2 \n      ISBN-          3 \n      Go Back-       4 \n";
cin>>x;
cout<<"      Enter query: ";
cin>>query;
cout<<"\n\n";
switch(x){
    case 1: for (int i=0;i<1000,lib[i].isbn!="0";i++){
        if (lib[i].name.find(query)<=lib[i].name.length()) {
                cout<<lib[i].name<<"\t"<<lib[i].author<<"\tISBN"<<lib[i].isbn<<"\t";
                if (lib[i].left_copy>0) cout<<" Available \n\n"; else cout<<" Unavailable \n\n";
        }} break;
    case 2: for (int i=0;i<1000,lib[i].isbn!="0";i++){
        if (lib[i].author.find(query)<=lib[i].author.length()) {
                cout<<lib[i].name<<"\t"<<lib[i].author<<"\tISBN"<<lib[i].isbn<<"\t";
                if (lib[i].left_copy>0) cout<<" Available \n\n"; else cout<<" Unavailable \n\n";
        }} break;
    case 3: for (int i=0;i<1000,lib[i].isbn!="0";i++){
        if (lib[i].isbn.find(query)<=lib[i].isbn.length()) {
                cout<<lib[i].name<<"\t"<<lib[i].author<<"\tISBN"<<lib[i].isbn<<"\t";
                if (lib[i].left_copy>0) cout<<" Available \n\n"; else cout<<" Unavailable \n\n";
        }} break;
    case 4: return a;
}
string isbn; int i; char c;
cout<<"\n   Enter ISBN number of book you want to issue: \n";
cin>>isbn;
for (i=0;i<1000;i++){
    if (lib[i].isbn==isbn) {cout<<"\n"<<lib[i].name<<"\t"<<lib[i].author<<"\n"; break;}
}
if (i==1000) {cout<<"   Invalid input. \n"; return a;}
if (lib[i].left_copy>0) {
        cout<<"   Issue? y/n "; cin>>c;
        if (c=='n' || c=='N') return a;
        if (a.issued_book!="0") {cout<<"\n   Return previously issued book first. \n"; return a;}
        if (lib[i].resrvd==0 || lib[i].resrvd==a.rollno){
            a.issued_book=lib[i].isbn;
            lib[i].left_copy--;
            lib[i].resrvd=0;
            cout<<"\n   Book issued. \n";
            return a;
            }
        if (lib[i].resrvd!=0 && lib[i].resrvd!=a.rollno) {cout<<"\n   Book is reserved by someone else. Try later.  \n"; return a;}
}
else {
        cout<<"   Reserve? y/n "; cin>>c;
        if (c=='n' || c=='N') return a;
        if (lib[i].resrvd==0) {lib[i].resrvd=a.rollno; cout<<"\n   Book reserved. \n";}
        else cout<<"\n   Book is reserved by someone else. Try later. \n";
}
return a;
}

void reqbook(){
string req;
cout<<"\n   Enter name of book you want to request: ";
cin>>req;
ofstream requests("requests.txt", ios::ate | ios::app);
requests<<req<<"\n";
cout<<"\n      Request submitted. \n";
requests.close();
return;
}

void liboptions(librarian b,book lib[]){
int j=1,x;
do{
cout<<"Enter choice: \n   Add book-                1 \n   Delete book-             2 \n   View requests-           3 \n   Exit-                    4\n";
cin>>x;
switch(x){
    case 1:addbook(lib); break;
    case 2:deletebook(lib); break;
    case 3:viewreq(lib); break;
    case 4:j=0;break;
    default: cout<<"   Invalid input. \n";
}
}while (j);
}

void addbook(book lib[]){
int x;
cout<<"   Add new book-                 1 \n   Add copies of existing book-  2   \n";
cin>>x;
if (x==1){
        string name,author,isbn,a; int copies,i;
        getline(cin,a);
        cout<<"\n   Enter details: ";
        cout<<"\n      Name: ";
        getline(cin,name);
        cout<<"\n      Author: ";
        getline(cin,author);
        cout<<"\n      ISBN: ";
        getline(cin,isbn);
        cout<<"\n      Number of copies: ";
        cin>>copies;
        for (i=0;i<1000,lib[i].isbn!="0";i++){
                if (lib[i].isbn==isbn) {cout<<"\n   ISBN already exists. \n";return;}
        }
        lib[i].name=name;
        lib[i].author=author;
        lib[i].isbn=isbn;
        lib[i].total_copy=copies;lib[i].left_copy=copies;
        lib[i].resrvd=0;
        cout<<"\n   Book added to database. \n";
        return;
}
if (x==2){
        string isbn;int i,add;
        cout<<"   Enter ISBN: ";
        cin>>isbn;
        for (i=0;i<1000;i++){
            if (lib[i].isbn==isbn) break;
        }
        cout<<"\n   Enter number of copies to be added: ";
        cin>>add;
        lib[i].total_copy+=add;
        lib[i].left_copy+=add;
        cout<<"\n      Database updated. \n";
        return;
}
}

void deletebook(book lib[]){
string isbn;
int i;
char c;
cout<<"   Enter ISBN: ";
cin>>isbn;
for (i=0;i<1000;i++){
    if (lib[i].isbn==isbn) break;
}
cout<<lib[i].name<<"\t"<<lib[i].author<<"\n      Confirm delete? y/n";
cin>>c;
if (c=='y'){
for (;i<1000,lib[i].isbn!="0";i++){
    lib[i].name=lib[i+1].name;
    lib[i].author=lib[i+1].author;
    lib[i].isbn=lib[i+1].isbn;
    lib[i].total_copy=lib[i+1].total_copy;
    lib[i].left_copy=lib[i+1].left_copy;
    lib[i].resrvd=lib[i+1].resrvd;
}
cout<<"\n      Book deleted from database. \n";
}
return;
}

void viewreq(book lib[]){
string temp;
int x;
ifstream requests("requests.txt");
while (getline(requests,temp)) cout<<"   "<<temp<<"\n";
cout<<" Enter choice: \n   Add book-      1\n   Go back-       2\n";
cin>>x;
if (x==1) addbook(lib);
if (x==2) return;
return;
}

int num(string x){
int len,sum=0,a;
len=x.length();
for (int i=len-1,j=1;i>=0;i--,j*=10){
    a=x[i]-48;
    sum=sum+(a*j);
}
return sum;
}
